let child_process = require('child_process');
let fs = require('fs');

let toolsDir = __dirname;
let srcDir = toolsDir + "/../src";
let intermediateDir = toolsDir + "/../.intermediate";
let nodeModulesDir = toolsDir + "/../node_modules";

if (!fs.existsSync(intermediateDir)){
    fs.mkdirSync(intermediateDir);
}

if (!fs.existsSync(intermediateDir+'/app')){
    fs.mkdirSync(intermediateDir+'/app');
}

let commands = [
	() => child_process.fork(nodeModulesDir + '/node-sass/bin/node-sass', ['simulator.scss', '../.intermediate/simulator.css'], {'cwd': srcDir}),
	() => child_process.fork(toolsDir + '/purify.js', {'cwd': srcDir}),
	() => child_process.fork(toolsDir + '/embed.js'),
	() => child_process.fork(nodeModulesDir + '/typescript/lib/tsc.js', {'cwd': srcDir})
];

let commandIdx = 0;

function executeCommand(commandIdx) {
	console.log("Executing: " + commands[commandIdx].toString().replace(/\(\) => child_process\.fork/g, '').replace(/\(|\)$/g, ''));
	let process = commands[commandIdx]();
	process.on('close', (exitCode) => {
		if(exitCode != 0) throw "Command " + commands[commandIdx] + " failed with code " + exitCode;
		commandIdx += 1;
		if(commandIdx == commands.length)
		{
			console.log("Done.");
			return;
		}
		executeCommand(commandIdx);
	});
}

executeCommand(commandIdx);
